<?php

namespace FiloBlu\Flow\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class ParseCommand
 * @package FiloBlu\Flow\Console\Command
 */
class BaseCommand extends Command
{
    /**
     * @var \Magento\Framework\App\State
     */
    protected $state;

    /**
     * @var \FiloBlu\Flow\Cron\FetchFactory
     */
    protected $fetchFactory;

    /**
     * BaseCommand constructor.
     * @param \Magento\Framework\App\State $state
     * @param \FiloBlu\Flow\Cron\FetchFactory $fetchFactory
     * @param string $name
     */
    public function __construct(
        \Magento\Framework\App\State $state,
        \FiloBlu\Flow\Cron\FetchFactory $fetchFactory,
        $name = null
    )
    {
        $this->state = $state;
        $this->fetchFactory = $fetchFactory;
        parent::__construct($name);
    }

    /**
     * @param OutputInterface $output
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function ensureAreaCode(OutputInterface $output)
    {
        try {
            $this->state->setAreaCode(\Magento\Framework\App\Area::AREA_ADMINHTML);
        } catch (\Exception $e) {
            $currentAreaCode = $this->state->getAreaCode();
            $output->writeln("Area code was already set to {$currentAreaCode}");
        }
    }
}